#include "menu.h"

#include <stdio.h>
#include <malloc.h>
extern char* vba32_rom_path, *vba32_rom_file, *last_dir;
extern int dir_depth;

char *text_str_load_separator="--------------------------------";
char *text_str_load_dir="#DIR#";
char *text_str_load_title="Load ROM";
#ifdef _arch_dreamcast
#include "kos/fs.h"
dirent_t *text_dir_files=NULL;
char *text_dir_attr=NULL;
int text_dir_num_files=0, text_dir_num_files_index=0;
file_t fd;
file_t d;
dirent_t *de;
#endif
int amt,amt2=0;
char *text_load=NULL;
int ft=0;
extern int num_joys;//=0;
extern SDL_Joystick *joys[4];
#define SHOW_MAX_FILES 11

static inline int getFiles(char *dir)
{
#ifdef _arch_dreamcast
	int j;
//	char name[50];
	char path[30];
	//GPFILEATTR p_attr;
//	unsigned long tmp,tmp2=0;
    amt=amt2=0;
	text_dir_num_files_index=0;
	text_dir_num_files=0;

	if (text_dir_files!=NULL)
		free(text_dir_files);

	if (text_dir_attr!=NULL)
		free(text_dir_attr);

	//GpFatInit();

	text_draw_window(96,64,140,32,"-------");
	write_text(14,9,"Please wait");
	SDL_Flip(text_screen);
/*
	if ((strcmp(dir,"gp:\\"))&&(strcmp(dir,"GP:\\"))&&(strcmp(dir,"\\"))&&(strlen(dir)))
	{
		//GpRelativePathSet(dir);
		//if ( GpDirEnumNum(".", &tmp)!=SM_OK )
		//	return -1;
	}
	else
	{
		//if ( GpDirEnumNum("gp:\\", &tmp)!=SM_OK )
		//	return -1;
	}
	if (tmp<1)
		return -1;
*/
  /* Read and print the root directory */
  sprintf(path,"%s",dir);
  printf("PATH=%s\n",path);
   d = fs_open(path, O_RDONLY | O_DIR);
   if (d == 0) {
      printf("1Can't open root!\r\n");
      return -1;
   }
    while ( (de = fs_readdir(d)) ) {
      printf("%s  /  ", de->name);
      if (de->size >= 0) {
         printf("%d\r\n", de->size);
         amt++;
      } else {
         printf("DIR\r\n");
         amt2++;
      }
   }
   printf("there are %d files in root and %d directories\n",amt,amt2);
   fs_close(d);

   	text_dir_num_files=amt+amt2+1;

	text_dir_files=(dirent_t *)calloc(sizeof(dirent_t),text_dir_num_files);

	if (text_dir_files==NULL)
	{
	    free(text_dir_files);
		return -2;
	}
	text_dir_attr=(char *)calloc(1,text_dir_num_files);
	if (text_dir_attr==NULL)
	{
		free(text_dir_attr);
		return -3;
	}
	j=0;
	d = fs_open(path, O_RDONLY | O_DIR);
	if (d == 0) {
      printf("2Can't open root!\r\n");
      return -1;
    }
    if (strcmp(vba32_rom_path,"/cd"))
    {
        strncpy((char *)&text_dir_files[j].name, "..", 50);
        text_dir_attr[j++]=1;
    }
    else
    {
        text_dir_num_files--;
    }
    while ( (de = fs_readdir(d)) ) {
    //strncpy((char *)&name,(char *)&de->name,50);
    if ( strcmp((char *)&de->name,"1st_read.bin")   && strcmp((char *)&de->name,"dcvba32.bin") )
    {
        strncpy((char *)&text_dir_files[j].name, (char *)&de->name, 50);
        printf("%d - %s\n",j, (char *)&text_dir_files[j].name);
        if (de->size >= 0) {
        	text_dir_attr[j]=0;
       	}
       	else
       	{
       		text_dir_attr[j]=1;
    	}
    	j++;
   	}
   	else
   	    text_dir_num_files--;
	}
	fs_close(d);
    /*
	if ((strcmp(dir,"gp:\\"))&&(strcmp(dir,"GP:\\"))&&(strcmp(dir,"\\"))&&(strlen(dir)))
		GpDirEnumList(".", 0, tmp, text_dir_files, &tmp2);
	else
		GpDirEnumList("gp:\\", 0, tmp, text_dir_files, &tmp2);
	text_dir_num_files=tmp2;

	for(i=0;i<tmp2;i++)
	{
		GpFileAttr((char *)&text_dir_files[i].name, &p_attr);
		if (!(p_attr.attr&0x10))
		{
			for(j=i+1;j<tmp2;j++)
			{
				GpFileAttr((char *)&text_dir_files[j].name, &p_attr);
				if (p_attr.attr&0x10)
				{
					strncpy((char *)&name,(char *)&text_dir_files[j].name,50);
					strncpy((char *)&text_dir_files[j].name, (char *)&text_dir_files[i].name, 50);
					strncpy((char *)&text_dir_files[i].name, (char *)&name, 50);
					break;
				}
			}
			if (j==tmp2)
				break;
		}
	}

	for(i=0;i<tmp2;i++)
	{
		GpFileAttr((char *)&text_dir_files[i].name, &p_attr);
		if (p_attr.attr&0x10)
			text_dir_attr[i]=1;
		else
			text_dir_attr[i]=0;
	}

	for(i=0;i<tmp2;i++)
		if (!strcmp(".",(char *)&text_dir_files[i]))
			break;

	if (i==tmp2)
		for(i=0;i<tmp2;i++)
			text_dir_attr[i]=1;


	for(i=0,tmp=0;i<tmp2;i++)
	{
		int l=strlen((char *)&text_dir_files[i]);
		char *st=(char *)(((void *)&text_dir_files[i])+l-3);
		if	(
				(!strcmp("GBC",st)) ||
				(!strcmp("GBA",st)) ||
				(!strcmp("ZIP",st)) ||
				(!strcmp(".GB",st)) ||
				(!strcmp("gbc",st)) ||
				(!strcmp("gba",st)) ||
				(!strcmp(".gb",st)) ||
				(text_dir_attr[i])
			)
		{
			if (tmp!=i)
			{
				strcpy((char *)&text_dir_files[tmp],(char *)&text_dir_files[i]);
				text_dir_attr[tmp]=text_dir_attr[i];
			}
			tmp++;
		}
	}
	text_dir_num_files=tmp;
*/
#endif
	return 0;

}

static inline void draw_loadMenu()
{
	int i,j,min=0,max=SHOW_MAX_FILES;
	static int b=0;
	int bb=(b%6)/3;

	text_draw_background();
	text_draw_window(40,24,260,200,text_str_load_title);
#ifdef _arch_dreamcast
	if (text_dir_num_files_index>=SHOW_MAX_FILES)
	{
		min=text_dir_num_files_index-SHOW_MAX_FILES+1;
		max=min+SHOW_MAX_FILES;
	}
	if (max>text_dir_num_files)
		max=text_dir_num_files-min;


	for (i=min,j=1;i<max;i++,j+=2)
	{
		write_text(5,j+2,text_str_load_separator);
		if ((text_dir_num_files_index==i)&&(bb))
			write_text_inv(6,j+3,(char *)&text_dir_files[i].name);
		else
			write_text(6,j+3,(char *)&text_dir_files[i].name);
		if (text_dir_attr[i])
			write_text(32,j+3,text_str_load_dir);
	}
	write_text(5,j+2,text_str_load_separator);
#endif
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(50);
#endif
	b++;
}

static inline int key_loadMenu()
{
	int end=0;
	int left=0, right=0, up=0, down=0, hit0=0, hit1=0;
	int getleft,getright,getup,getdown,getA,getStart=0;
	int joyleft,joyright,joyup,joydown,joyA,joyStart=0;
	SDL_Event event;

	while (SDL_PollEvent(&event) > 0)
	{
		if (event.type == SDL_QUIT)
			end=-1;
		else
		if (event.type == SDL_KEYDOWN)
		{
			switch(event.key.keysym.sym)
			{
				case SDLK_BACKSPACE: right=1; break;
				case SDLK_TAB: left=1; break;
				case SDLK_UP: up=1; break;
				case SDLK_DOWN: down=1; break;
				case SDLK_LCTRL: hit0=1; break;
				case SDLK_LALT: hit1=1; break;
				default: break;
			}
		}
		else
    	if (event.type == SDL_JOYHATMOTION)
     	{
     		joyup=JOY_HATUP(0);
     		joydown=JOY_HATDOWN(0);
     		joyleft=JOY_HATLEFT(0);
     		joyright=JOY_HATRIGHT(0);
      		if (joyup )//&& !getup)
			{
				up=1;
			}
			getup=joyup;
      		if (joydown )//&& !getdown)
			{
				down=1;
			}
			getdown=joydown;
      		if (joyleft )//&& !getleft)
			{
				left=1;
			}
			getleft=joyleft;
      		if (joyright )//&& !getright)
			{
				right=1;
			}
			getright=joyright;
  		}
  		else
    	if (event.type == SDL_JOYBUTTONDOWN || event.type == SDL_JOYBUTTONUP)
     	{
     		joyA=JOY_A(0);
     		joyStart=JOY_START(0);

      		if (joyA )//&& !getA)
			{
				hit0=1;
			}
			getA=joyA;
      		if (joyStart )//&& !getStart)
			{
				hit1=1;
			}
			getStart=joyStart;
		}
			if (hit0)
			{
#ifdef _arch_dreamcast
				if ((text_dir_attr[text_dir_num_files_index])||(!strcmp((char *)&text_dir_files[text_dir_num_files_index],"."))||(!strcmp((char *)&text_dir_files[text_dir_num_files_index],"..")))
				{

					if (strcmp((char*)&text_dir_files[text_dir_num_files_index].name,".."))
					{
//                        write_text_inv(5,13,vba32_rom_path);
//					    SDL_Delay(2000);

                        strcpy((char*)&last_dir[dir_depth],vba32_rom_path);
                        dir_depth++;
     					strcat(vba32_rom_path,"/");
     					strcat(vba32_rom_path,text_dir_files[text_dir_num_files_index].name);
     					//fs_chdir ( vba32_rom_path );
                        //write_text_inv(5,13,vba32_rom_path);
					    //SDL_Delay(2000);
     					getFiles(vba32_rom_path);

					}
					else
					{
                        dir_depth--;
                        if (dir_depth <1)
                        {
                            strcpy(vba32_rom_path,"/cd");
                        }
                        else{
                        strcpy(vba32_rom_path,(char*)&last_dir[dir_depth]);
                        }
     					getFiles(vba32_rom_path);
                    }


				}
				else
				{
					//GpRelativePathGet(vba32_rom_path);
					strcpy(vba32_rom_file,vba32_rom_path);
					strcat(vba32_rom_file,"/");
					strcat(vba32_rom_file,(char *)&text_dir_files[text_dir_num_files_index].name);
					//strcpy(vba32_rom_path,"/cd/");
					end=1;
					//vba32_rom_file=strcat(vba32_rom_path,vba32_rom_file);
					printf("%d - (%s)\n",text_dir_num_files_index,vba32_rom_file);

				}

			}
			else if (hit1)
			{
				end=-1;
			}
			else if ((up)&&(text_dir_num_files_index>0))
				text_dir_num_files_index--;
			else if ((down)&&(text_dir_num_files_index+1!=text_dir_num_files))
				text_dir_num_files_index++;
			else if (left)
			{
				text_dir_num_files_index-=SHOW_MAX_FILES;
				if (text_dir_num_files_index<0)
					text_dir_num_files_index=0;
			}
			else if (right)
			{
				text_dir_num_files_index+=SHOW_MAX_FILES;
				if (text_dir_num_files_index+1>=text_dir_num_files)
					text_dir_num_files_index=text_dir_num_files-1;
			}
#else
			}
			if (ft == 0 )
			{
//			vba32_rom_file="cd/GBamaTron.gb";
//			ft=1;
//			}
//			else if (ft == 1)
//			{
//			vba32_rom_file="cd/Scramble.cgb";
//			ft=2;
//			}
//			else
//			{
            vba32_rom_file="cd/DangerousXmas.bin";
            ft=0;
            }
			end=1;
			break;
#endif
		}


	return end;
}

static inline void raise_loadMenu()
{
	int i;
	num_joys = SDL_NumJoysticks();
	joys[0] = SDL_JoystickOpen(0);
	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
	for(i=0;i<10;i++)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_load_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
}

static inline void unraise_loadMenu()
{
	int i;

	for(i=9;i>=0;i--)
	{
		text_draw_background();
		text_draw_window(40,(10-i)*24,260,200,text_str_load_title);
		SDL_Flip(text_screen);
#ifndef GP32
		SDL_Delay(10);
#endif
	}
	text_draw_background();
	SDL_Flip(text_screen);
#ifndef GP32
	SDL_Delay(20);
#endif
}



int run_menuLoad()
{
	int end=0,c=0;

	if (vba32_rom_path!=NULL)
	{	free(vba32_rom_path);
	    vba32_rom_path=NULL;
	}

	if (vba32_rom_file!=NULL)
		free(vba32_rom_file);

	if (last_dir!=NULL)
		free(last_dir);

	if (vba32_rom_path==NULL)
	{
		vba32_rom_path=(char *)calloc(1,1024);
		vba32_rom_file=(char *)calloc(1,1024);
		last_dir=(char *)calloc(50,1024);
#ifdef _arch_dreamcast
		strcpy(vba32_rom_path,"/cd");
	}

	if (text_dir_files==NULL)
		end=getFiles(vba32_rom_path);
	//else
		//GpRelativePathSet(vba32_rom_path);
		//fs_chdir ( vba32_rom_path );


	text_dir_num_files_index=0;

#else
	}
#endif
	raise_loadMenu();
	while(!end)
	{
		draw_loadMenu(c);
		end=key_loadMenu(&c);
	}
	unraise_loadMenu();

//				free(vba32_rom_path);
//				free(vba32_rom_file);
//				free(last_dir);


	return end;
}
